; These have been embeded in the C source file (jcpplisp.cpp).
;						30 June 2017

    (setq pi 3.14159265358979)

    (defun oddp (n) (cond ((evenp n) nil) (t t)))

    (defun append1 (x y) (cond ((atom x) y) (t (cons (car x) (append1 (cdr x) y)))))

    (defmacro loop1 (&rest b) (append1 (append1 (list 'prog '() 'label) b) (list '(go label))));)

    (defmacro loop (&rest b) (append1 (append1 (list 'prog '() 'label) b) (list '(go label))));)

    (defmacro dolist (&rest b)
	(append1
	    (list 'prog `(,(car (car b)))
		`(setq list ,(car (cdr (car b))))
		'label
                `(if (null list) (setq ,(car (car b)) nil))
		`(if (null list) ,(list 'return (cond ((null (cdr (cdr (car b)))) nil) (t (car (cdr (cdr (car b))))))))
                `(setq ,(car (car b)) (car list))
	    )
	    (append1 (cdr b) (list '(setq list (cdr list)) '(go label))) ) )

    (defmacro dotimes (&rest b)
	`(prog (,(car (car b)))
	    (setq ,(car (car b)) 0)
	    label
	    (if (= ,(car (car b)) ,(car (cdr (car b))))
                (return ,(cond ((null (cdr (cdr (car b)))) nil) (t (car (cdr (cdr (car b))))))) )
            ,@(cdr b)
                (setq ,(car (car b)) (1+ ,(car (car b))))
            (go label) ) )

    (defun load (fname)
	(let ((strm) (s))
	    (setq strm (open fname))
	    (if (null strm) nil
	        (loop1
		    (if (null (setq s (read strm nil))) (progn (close strm) (return t)))
		    (eval s) ) ) ) )

    (defmacro with-open-file (a &rest b)
	`(let ((,(car a) (open ,@(cdr a))))
	    (unwind-protect
		(if (null ,(car a)) nil
		    (progn ,@b) )
		(if (not (null ,(car a)))
		    (progn (close ,(car a)) (print 'closed)) ) ) ) )

    (defun not (e) (cond ((null e) t) (t nil)))

    (defun zerop (x) (cond ((= x 0) t) (t nil)))

    (defun listp (x) (cond ((null x) t) ((not (atom x)) t) (t nil)))

    (defun > (x y) (cond ((minusp (- x y)) nil) ((zerop (- x y)) nil) (t t)))

    (defun >= (x y) (cond ((minusp (- x y)) nil) (t t)))

    (defun < (x y) (cond ((minusp (- x y)) t) (t nil)))

    (defun <= (x y) (cond ((minusp (- x y)) t) ((zerop (- x y)) t) (t nil)))

    (defun equal (x y)
	(if (atom x) (eql x y)
	    (if (atom y) nil
		(if (equal (car x) (car y))
		    (equal (cdr x) (cdr y))
		    nil ) ) ) )

    (defun subseq (x m &rest n)
	(let ((ans nil) (len) (k (if (atom n) nil (car n))))
	    (cond
	        ((stringp x)
	         (cond
		    ((null k) (setq len (length x))
		     (loop
			(if (= m len) (return (coerce ans 'string)))
			(setq ans (append ans (list (char x m))))
			(setq m (1+ m)) ) )
		    (t
		     (loop
			(if (= m k) (return (coerce ans 'string)))
			(setq ans (append ans (list (char x m))))
			(setq m (1+ m)) ) ) ) )
	        (t
	         (cond
		    ((null k) (setq len (length x))
		     (loop
			(if (= m len) (return ans))
			(setq ans (append ans (list (nth m x))))
			(setq m (1+ m)) ) )
		    (t
		     (loop
			(if (= m k) (return ans))
			(setq ans (append ans (list (nth m x))))
			(setq m (1+ m)) ) ) ) ) ) ) )

    (defun nth (n lst)
	(let ((k 0))
	    (loop
	        (if (= k n) (return (car lst)))
	        (setq lst (cdr lst))
	        (setq k (1+ k)) ) ) )

    (defun pprint (x)
        (pprint2 x 0)
        (terpri)
        t )

    (defun pprint2 (x n)
        (cond
            ((atom x) (spaces n) (prin1 x))
            ((is-all-atom-1-list x) (spaces n) (prin1 x))
            (t
             (spaces n)
             (princ #\\()
             (pprint3 (car x) (+ n 1))
             (setq x (cdr x))
             (loop
                 (if (atom x) (return))
                 (terpri)
                 (pprint2 (car x) (+ n 1))
                 (setq x (cdr x)) )
             (princ #\\)) ) ) )

    (defun pprint3 (x n)
        (cond
            ((atom x) (prin1 x))
            ((is-all-atom-1-list x) (prin1 x))
            (t
             (princ #\\()
             (pprint3 (car x) (+ n 1))
             (setq x (cdr x))
             (loop
                 (if (atom x) (return))
                 (terpri)
                 (pprint2 (car x) (+ n 1))
                 (setq x (cdr x)) )
         (princ #\\)) ) ) )

    (defun is-all-atom (x)
        (loop
            (if (atom x) (return t))
            (if (not (atom (car x))) (return nil))
            (setq x (cdr x)) ) )

    (defun is-all-atom-1-list (x)
        (loop
            (if (atom x) (return t))
            (if (and (not (atom (car x))) (not (is-all-atom (car x)))) (return nil))
            (setq x (cdr x)) ) )

    (defmacro append (&rest l)
        (cond
	    ((null l) nil)
	    ((null (cdr l)) (car l))
	    (t (list 'append1 (car l)
		    (cons 'append (cdr l)) ) ) ) )

    (defun reverse (x)
	(cond
	    ((stringp x) (coerce (reverse1 (coerce x 'list)) 'string))
	    (t (reverse1 x)) ) )

    (defun reverse1 (x)
	(cond
	    ((atom x) x)
	    (t (append (reverse (cdr x)) (cons (car x) nil))) ) )

    (defun multiple-value-born$ (arg value)
        (cond
	    ((null arg) nil)
	    ((null value) (cons (list 'setq (car arg) 'nil) (multiple-value-born$ (cdr arg) value)))
	    (t (cons (list 'setq (car arg) (list 'quote (car value))) (multiple-value-born$ (cdr arg) (cdr value)))) ) )

    (defmacro multiple-value-setq (a b) `(multiple-value-setq$ ,a ,(multiple-value-list (eval1 b))))

    (defmacro multiple-value-setq$ (a b) `(prog1 ,@(multiple-value-born$ a b)))

    (defmacro multiple-value-bind (a b &rest c) `(let ,(mapcar #'list a) (multiple-value-setq ,a ,b) ,@c))

    (defun mapcar (func a &rest b)
        (cond
	    ((atom a) nil)
	    ((and (not (atom b)) (atom (car b))) nil)
	    ((atom b) (cons
                         (funcall func (car a))
                         (mapcar func (cdr a)) ) )
            (t (cons (apply func (cons (car a) (list (car (car b)))))
		     (mapcar func (cdr a) (cdr (car b))) ) ) ) )

    (defun member (item lst &rest a)
        (let ((test (if (and (not (null a))
                             (eq :test (car a))
			     (not (atom (cdr a))) )
		        (car (cdr a))
		    #'eql) ) )
	    (if (null lst) nil
	        (if (funcall test item (car lst)) lst
		    (member item (cdr lst) :test test)))))

    (defun first (x) (car x))

    (defun rest (x) (cdr x))

    (defun char= (x y) (char-equal x y))

    (defun char/= (x y) (not (char-equal x y)))

    (defun char> (x y) (char< y x))

    (defun char<= (x y) (or (char< x y) (char= x y)))

    (defun char>= (x y) (or (char> x y) (char= x y)))

    (defmacro lambda (&rest b) `(function (lambda ,@b)))


